'use strict'

function makeLine(size, char = '#') {
	let str = '';
	for (let i = 0; i < size; i++) {
		str += char;
	}
	return str;
}



function makeSquare(size) {
	let str = '';
	for (let i = 0; i < size; i++) {
		str += makeLine(size) + '\n';
	}
	return str.trim();
}



function makeRectangle(width, height = width) {  //height = width zorgt er voor dat de functie ook werkt met maar 1 parameter
	let str = '';
	for (let i = 0; i < height; i++) {
		str += makeLine(width) + '\n';
	}
	return str.trim();
}



function makeDownwardStairs(size) {
	let str = '';
	for (let i = 1; i <= size; i++) {
		str += makeLine(i) + '\n';
	}
	return str.trim();
}



function makeSpaceLine(numSpaces, numChars) {
	return makeLine(numSpaces, ' ') + makeLine(numChars, '#') + makeLine(numSpaces, ' ');
}



function makeIsoscelesTriangle(height, offset = 0) {
	let str = '';
	for (let i = 0; i < height; i++) {
		str += makeSpaceLine(height - i - 1 + offset, 2 * i + 1) + '\n';
	}
	return str.trimEnd();
}



function reverseString(str) {
	return str.split('').reverse().join('');
}

function makeDiamond(height) {
	return makeIsoscelesTriangle(height - 1, 1) + '\n' + reverseString(makeIsoscelesTriangle(height));
}

